Changes UI-View32 V1.80 -> V2.03
--------------------------------
Please note:-

(a) The changes are divided into two sections, first "New Features",
then "The Following Bugs Have Been Fixed". In each section, the
changes are listed by version number, and the most recent changes are
shown first.

(b) Some versions were not generally released. The changes made in
those versions are shown as being in the next generally released
version.

New Features
------------
V2.02
-----
1. There is a new world map - The World In Colour. It is a great
improvement over the previous World map. It has been supplied by David
Taylor of WXTrack fame for exclusive use with UI-View.

2. On the Setup tab of the IGATE.INI Editor, there is a new option -
'Gate all RF to INET'. Read the help to find out what it does.

3. On the "Inet to RF" tab of the IGATE.INI Editor, it is now possible
to gate traffic by message recipient (addressee) - RECIP in the
drop-down list.

4. "Wx data file" in "WX Station Setup" can now be a program file that
will create the real wx data file. See the comments about "Wx data
file" in the "WX Station Setup" section of the help.

5. When measuring distances of less than a mile / less than 1 km, the
distance and bearing tool now displays then in yards / metres.

6. There is a new option on the Message window Options menu - Auto
Wrap. Read the "Message Menus" section of the help to find out what it
does.

7. The Message window Text input box shows the number of characters
still available in the current message.

V1.99
-----
1. Station information tooltips are available on the map window - see
the "Tooltip Text Setup" dialogue on the Setup menu.

2. The unproto paths for traffic gated from the internet to RF can now
be set to be different to the paths used for the station posit beacon.
See the IGATE.INI Editor help.

3. On the "Inet to RF" tab of the IGATE.INI Editor, it is now possible
to gate traffic by destination address - DEST in the drop-down list.
Example - if you input  Callsign CQ = DEST  then all frames addressed
to CQ will be gated.

4. "Alert When Digi'd" option added to the Options menu. If this
options is checked, then UI-View32 plays DIGID.WAV when it sees its
own frames digipeated.

5. When used mobile, UI-View32 now calculates the distances and
bearings in the Station List from the current mobile location.
(Previously it used the location in Station Setup.)

6. A "Track cross-hairs" option has been added to the "Cross-hairs
Setup" dialogue in the "GPS Setup" dialogue.

7. When using a map server with "Alternate Mouse Actions" enabled, a
double right-click on the map will centre the map on that point.

8. "Show label background" option added to "Miscellaneous Setup". If
this option is not checked, then the callsign labels on the map are
displayed without the usual rectangular background.

9. F11 is now a shortcut for "Query All Stations".

V1.97
-----
1. Higher GPS baud rates are now supported in "GPS Setup".

2. VBscripts for running multiple configurations - see MULTICFG.HLP.

3. "Use Default Path For Acks" option added to the Message window. See
the "Message Menus" section of the help to find out what it does.

4. "Receive only" option added to the "Comms Setup" dialogue.

5. Some extra properties and methods added to the ActiveX interface.

6. A web server plug-in - UI-WebServer - is now included with the
program.

7. REJ responses to messages now cause UI-View32 to stop trying to
send the message, and to alert you that a REJ was received.

8. "Delete All Stations" option added to the Action menu.

9. Options added to UI-NWS to automatically print the NWS messages,
see the "Miscellaneous Setup" section of the UI-NWS help. Also, there
is now a Print option on the "Finger WxSvr" window.

V1.94
-----
1. D700 button added to "Easy Setup" in "KISS Setup". The commands it
puts in "Into KISS" will put the TM-D700 into KISS mode without the
user needing to first manually switch the radio into "TNC PKT" mode.

2. "Max silence" setting added to the "APRS Server Setup" dialogue,
read the help for the dialogue to find out what it does.

3. UI-View32 now displays area objects as defined in the APRS spec.
(Actually, that isn't quite true, because the definition in the spec
has several major errors in it!)

4. UI-View32 now displays area objects in the format used by KG5QD's
WxSvr. (For information on WxSvr see http://wxsvr.net/)

5. If you right-click an object that appears to be a WxSvr weather
object, then the pop-up menu has a "Finger WxSvr" option, which can be
used to get the full text of the NWS alert associated with the object.

6. The "Objects and Items" list now has a Finger button, which is
enabled if the highlighted object in the list appears to be a WxSvr
weather object.

7. Some enhancements made to the UI-View32 API -

   (a) The interface for external programs to send and receive APRS
       messages has been significantly improved.

   (b) External programs can now use UI-View32 to speak callsigns.

   (c) A formal definition of the UI-View32 ActiveX interface, in PDF
       format, is included in UIV32X.ZIP.

V1.93
-----
1. "Sort Lists" option added to the Lists menu. If you check it, then
the callsigns in the lists are sorted in alphanumeric order.

V1.90
-----
1. Major changes have been made to the message retry algorithms. See
the "Message Retries" section of the help.

2. UI-View32 can now be used on Windows system that use a double byte
character set (DBCS). Previous versions would not run at all if a DBCS
was being used. To try and help with the display of frames that contain
DBCS characters, two new options have been added - "Translate to
ASCII" in "Miscellaneous Setup", and "Use binary filter" in "Comms
Setup". The default settings for these two options cause UI-View32 to
behave the same as previous versions. See the relevant sections of the
help file for more information.

3. Some changes have been made to UI-NWS:-

   (a) If you double-click an active area on the UI-View32 map, and
       there is more than one active alert for the area, then details
       of all the alerts are displayed. (Previously only one alert was
       displayed.)

   (b) If you right-click on the UI-NWS areas or messages lists, then
       a pop-up menu appears, with an option to "Finger WxSvr". This
       allows you to obtain the full text of the NWS message that
       generated the APRS message. PLEASE READ the "Finger WxSvr"
       section of the UI-NWS help. Also, PLEASE NOTE that this feature
       will not work properly for any NWS alerts in your lists that
       were received before this new version of UI-NWS was installed.

   (c) If you double-click an NWS active area on the UI-View32 map,
       and then right-click the information window for the area, a
       pop-up menu appears with an option to "Finger WxSvr" (see
       above).

   (d) Expiring alerts is now done more efficiently.

   (e) Some minor errors in the parsing of the NWS messages have been
       fixed.

4. UI-View32 now understands posits sent in the $PNTS format that is
used in Japan. Also, $PNTS frames can be translated to APRS format if
they are gated between the internet and RF. See [CONVERT_PNTS] in the
IGATE.INI section of the help.

5. A new option on the Options menu - Show Symbols on Map (shortcut
CTRL+F5) - unchecking it provides a means of easily hiding the station
symbols on the map without using the exclusions. (It is really only
useful if you are using UI-NWS.)

6. "Extra log-on text" option added to the "APRS Server Setup"
dialogue. See the help for the dialogue for information on what it is
for.

7. An editor for IGATE.INI is now supplied. This makes it easier for
IGATE operators to alter their IGATE configuration. It is accessed
from "Edit IGATE.INI" on the File menu.

8. Some extra dupe checking added to the output from the local server.

9. When browsing for "Extra maps path" in "Miscellaneous Setup", the
browse starts at the currently selected path.

10. When using PmapServer, you can now zoom out with PgUp and zoom in
with PgDn, you do not need to press Ctrl.

11. Pressing Escape with the focus om the Message window will now
close the window.

12. You can now put entries in the [INET_TO_RF] section of IGATE.INI
specifying the names of objects that should be gated from the internet
to RF. See the IGATE.INI section of the help.

13. If you use callsign translations, the translations will be shown
on the title bar of the details windows.

14. UI-View32 now complies with the APRS spec requirement that "Object
names are case-sensitive". Previous versions did not comply, because I
think the spec has got it wrong! In the real world, most people would
regard the "ambulance" and the "Ambulance" as being the same thing,
but in the world of the APRS spec they are different objects.

V1.86
-----
1. UI-View32 now has full support for displaying the USA National
Weather Service (NWS) APRS messages. This is a major new feature. To
use it, select UI-NWS on the UI-View32 File menu, and read the help.

2. Support for systems using multiple monitors has been greatly
improved.

3. When an IGATE closes, it will now transmit an "IGATE,CLOSED" status
frame. This will remove the IGATE from the IGATE stations list on any
UI-View32 V1.85 or later system that hears the frame.

4. A /MIN command line switch is now available - it makes UI-View32
automatically minimize after it has started up.

5. "Exclusions Enabled" option put on the Options menu, and given a
shortcut key (Ctrl+F4), so it is now much easier to turn exclusions
on/off. (I have also left the option where it was previously - in the
"Exclude/Include Lists" dialogue.)

6. "Extra maps path" in "Miscellaneous Setup" will now accept network
paths. Also, a Browse button is available.

7. The "Capture Map" utility now has an option to capture the whole
screen rather than just the map window.

V1.84
-----
1. UI-View32 now fully supports IGATE status frames:-
(a) There is a new list - IGATE Stations.

(b) There is a new option on the Action menu - Query IGATEs.

(c) When UI-View32 is operating as an IGATE, it will respond to IGATE
    queries and broadcast its status.

For more information see the "IGATE Status Frames" and "IGATE List"
sections of the help.

2. The IGATE traffic window now has a local stations list, which shows
the stations that UI-View32 regards as being local to your IGATE.

3. A new plug-in is included, which can be used to create history
lists, create single callsign log files, and decode telemetry data for
selected stations. It appears on the File menu as UI-History. It has
its own help file, which will automatically open the first time you
run the plug-in.

4. Output of GPS data on a COM port or via TCP/IP is now supported.
See the "GPS Output Setup" section of the help.

5. The real-time position from the GPS can now be displayed on the
map. It is enabled with the new "Show GPS cross-hairs" option in the
"GPS Setup" dialogue, and configured using the "GPS Cross-hairs Setup"
dialogue.

6. Some improvements made to log playing -
(a) When playing a log, you can move backwards and forwards in the log
    by clicking and dragging on the "Replay date/time" box.

(b) The "Replay speed" can now be changed without having to pause the
    play.

(c) When you select a log from the drop-down list, the starting time
    of the log is immediately shown in the "Replay date/time" box.

7. A new option added to "Miscellaneous Setup" - "Only label
translations". If it is selected, then the only symbols on the map
that will be labelled are ones for which a translation has been input
in the "Edit Translations" dialogue. Note - you can translate a
callsign to itself, and so this option provides a means of only
labelling selected symbols, even if you wish to see the real callsigns
on the labels.

8. "Per-station APRS seq.nos" option added to the APRS Compatibility
dialogue. Open the dialogue, press F1, and read the help to find out
what it does. NOTE - the default is that this option is not checked,
which means UI-View32 now behaves slightly differently when seeing
acks to APRS messages you have sent.

9. The "Exclude/Include Lists" dialogue now has an "Enable exclusions"
checkbox, so you can easily temporarily disable any exclusions you set
by unchecking it.

10. For add-on developers - Three new methods have been added to the
clsUIV class. They are GetFrameInfo(), GetUivStats() and GetWxData().
For an example of how to use GetFrameInfo(), see the
mUIV_DataAvailable() event in the updated version of UIV32X.VBP. For
an exanple of how to use GetWxData(), see cmdStInfo_Click().


The Following Bugs Have Been Fixed
----------------------------------
V2.03
-----
1. If an APRS message was received with a blank destination address
then UI-View32 would ack it.

V2.02
-----
1. If you started to create a map INF file using drag 'n' drop, and
then closed the "Create An INF File" dialogue by using the window
close button (X), the map was not cleared up properly.

2. Imperial wind speed and gust values in the map tooltip text were
slightly different to the values in the wx details window for a
station, because one was assuming the speeds were in mph and the other
was assuming they were in knots.

3. The map tooltip text did not display the ampersand character.

4. If you used a KAM in terminal mode, and had MSTAMP ON, then, in
some situations, the list of digipeaters in received frame headers was
not interpreted correctly.

5. In the "APRS Server Setup" dialogue, if a server address was wider
than the list window, then the mouse tooltip was supposed to show the
address, but it did not work properly.

6. If a UI-View32 add-on sent a request to redraw the station symbols
while a map was being loaded, then some of the symbols could be drawn
incorrectly.

7. WinAPRS style wx data frames were never expired. This was not
usually a problem, but if a station changed from transmitting WinAPRS
style wx data to transmitting DOS APRS / UI-View style, then the last
WinAPRS style frame could appear in the details window indefinitely.

8. If you were playing a log faster than x1 speed, and you changed to
a slower speed, a long pause could occur in the replay.

9. If you put something like "RELAY, WIDE" in the Digi box in the
Message window, then the space after the comma was replaced with
another comma, it should have been removed.

10. In the message windows and some other text windows, it was
possible for a user to select the same colour for the text as for the
background, which would cause the text to be invisible.

11. If you used spaces instead of commas as the separator in "Unproto
address" in Station Setup, the path was parsed incorrectly.

12. Not a bug fix, but a change in behaviour - Having zero in the
radio beacon interval in "WX Station Setup" stopped F9 from sending
the wx beacon on both RF and on the internet port. If the internet
beacon interval is non-zero, then F9 will now send the beacon on the
internet only.

13. Not a bug fix, but a change in behaviour - Beacons sent to the
internet are now displayed in the Terminal window. Previously the
display was suppressed.

V1.99
-----
1. Deleting all stations could cause a problem with unloading
overlays.

2. If UI-View32 was running on Win NT/2000/XP and being used as a
local server, and the network connection to a client failed, it could
cause UI-View32 to terminate with a fatal error.

3. In "Wx Station Setup", if the radio beacon interval was set to
zero, it would prevent a wx beacon being sent on the internet.

4. It was not possible to input a '-' in callsigns in "Exclude/Include
Lists".

5. Callsigns in the Inet to RF section of the IGATE.INI Editor were
always sorted alphabetically. They should not have been, because the
sequence of the callsigns can be significant. They are now not sorted,
and the order in the list can be changed by dragging callsigns with
the mouse. Also, the help for the editor has been updated with some
explanation as to why the order can be significant.

6. UI-NWS did not always fully expand zone groups in NWS messages
(e.g. NJZ3>6) correctly.

7. If you opened the "Finger WxSvr" window in UI-NWS from the main
menu option, it was not correctly initialised. (It worked fine if you
opened it by right-clicking an area or message in the lists, which is
the normal way to use the finger facility.)

8. If you used AGWPE, UI-View32 could only handle 16 RF ports. That
was far more than enough for most users, but G8PZT's Xrouter, which
can emulate AGWPE, can provide internet ports that look like RF ports
to applications, and some Xrouter systems have more than 16 pseudo-RF
ports.

9. If an add-on used one particular feature of the UI-View32 API, it
could stop some overlay files from loading correctly.

10. If you received an APRS query of any sort, then the response was
sent to the destination address to which the query was addressed, not
the UI-View32 APRS destination address.

11. Not really a bug fix, but using an HSP for GPS COM port sharing
now works better than it previously did in WinXP.

12. Not really a bug fix - If a wx report had no wind speed, then the
display of wind direction in the wx details window was suppressed.
That is how I make my commercial wx station software behave. However,
some APRS wx stations seem to transmit gust but never transmit speed,
so wind direction is now always displayed, even if the speed is zero.

13. Not really a bug fix, but hardly a new feature - in previous
versions, if you used a destination unproto address of APRS, then it
was translated to APU2 followed by two characters that encoded the
program version. This has now been extended so APRS with an SSID is
also translated. E.g. APRS-10 would become APU2xx-10 (xx according to
the program version). This helps with SSID digipeating.

14. Not really a bug fix, but protection against bugs in other
programs - The format of the wx beacon data output by wx station
programs is now validated more rigorously before it is transmitted.

V1.97
-----
1. When using KISS mode with a dual port TNC, if the digipeater was
configured to output frames on both ports, they were only output on
port 1. (This problem was introduced in V1.93.)

2. When starting to play a log, NWS shapes were not removed from the
map.

3. If the "Clear All" button was used in the Message window, not all
information about failed messages was cleared, and this could lead to
problems when sending further messages.

4. Messages would sometimes get stuck with a status of 'H' and require
releasing manually.

5. If you used the "Download Internet Server List" option, then it was
possible for one server to appear multiple times in the servers list
in "APRS Server Setup".

6. The drag'n'drop map calibration method did not work if a map server
was loaded when you dropped the map on the map window.

7. The TCP/IP GPS output was outputting 16 bit Unicode characters.

8. If you closed UI-View32 while it was refreshing the map, it could
lock up.

9. If the callsign in "WX Station Setup" was left as NOCALL, then
messages to NOCALL would be acked. (This problem was introduced in
V1.94.)

10. "Per-station APRS message seq.no." in "APRS Compatibility" would
always be unchecked when UI-View32 was started.

11. Objects with lower case letters or spaces in their names could not
be excluded by name.

12. The time stamp in the details window for wx stations using
compressed posits was incorrect.

V1.94
-----
1. Some wx reports from stations using compressed posits were not
displayed correctly.

2. A work-round for a problem in the APRS NWS system - Some NWS
messages sent on APRS have an expiry time in the sender's local time.
It is impossible to reliably process these expiry times in other time
zones. If the use of local time results in an expiry time that is in
the past, or more than two weeks in the future, UI-NWS now sets the
expiry time to four hours.

3. If the wx station callsign was different to the station callsign,
then messages sent to it were ignored.

4. Manually deleting active areas in UI-NWS did not work properly.

5. If an unusual time or short date format was configured in Control
Panel, Regional settings, then UI-NWS could terminate with a "type
mismatch" error.

6. Not a bug fix, but an attempt to reduce the number of reports of a
non-existent bug - The following comment has been added to the SA Map
Grabber help, and to the "Street Atlas Virtual Map" section of the
UI-View32 help "It will not work with any of the new style versions of
Street Atlas, e.g. Street Atlas Deluxe, Street Atlas 2002 and Street
Atlas 2003. These programs have a completely different structure to
the old versions of Street Atlas. Even if it was possible to work out
the format of the saved map files (Delorme do not publish it), it is
impossible for an external program to feed in key strokes ..."

V1.93
-----
1. Not really a bug fix, but a small number of users reported problems
when using AGWPE and UI-View32 with Win2k, so I have altered the way
that UI-View32 handles fragmented frames from AGWPE.

V1.92
-----
1. A problem had been introduced in V1.90 that prevented external
programs being able to create objects via the ActiveX interface.

2. When using a PK-232 in terminal mode (host mode NONE), any digis
in the frame header were removed when frames were gated to the
internet.

V1.90
-----
1. If UI-View32 was minimized in the systray, and you closed it by
right-clicking the systray icon and selecting Exit from the pop-up
menu, then it would not always close any apps that were using it as an
ActiveX server.

2. If you didn't input your location in "Station Setup", and another
program was using one particular function of UI-View32's ActiveX
server interface, then it could cause all incoming posits to be
ignored.

3. When using PmapServer, with 'Alternate Mouse Actions' selected, if
you dropped down a menu, then clicked on the map to clear the menu,
the map would pan as if you had clicked the top edge of the map.

4. If a station was excluded, and it was seen IGATE'ing traffic, then
it would appear on the map.

5. In some locations, compressed posits were mistaken for an APRS
message sent in an obsolete format, so they weren't decoded.

6. If you ran UI-View32 in Win2k, and started NetMeeting after
UI-View32 had been started, UI-View32 would not display the details
window when you double-clicked a station.

7. The queuing of "speech" WAV files is now done differently, to
ensure that it is impossible to create a situation where the temporary
WAV files are not deleted.

8. If a mobile station was sending compressed format posits, then
height was not displayed in the details window, even it was included
in the posit comment. (NOTE - compressed format is not the same thing
as Mic-E format, and this problem only affected a very small number of
mobiles.)

9. If you selected a wx data file in "WX Station Setup", and then
deleted the file, UI-View32 would send an empty beacon frame.

V1.86
-----
1. If an object was excluded by its name, it would reappear the next
time it was heard.

2. If you double clicked the column headers of the station list or the
IGATE stations list to sort on a column, instead of single clicking,
then a detail window would open for the currently highlighted station
in the list.

3. If you used UI-View32 as a local server, and you had not connected
to an internet server since starting the program, then other stations
connected to your server would not be gated to RF.

4. If you clicked twice in very quick succession on the previous map
and next map buttons, you could confuse UI-View32 as to where it was
in the maps history list.

5. If a station was excluded, and an IGATE status message was seen
from it, then it would appear on the map.

6. UI-History did not extract the bits information from a "BITS."
telemetry message if there was no comma between the bits and the
project name.

V1.84
-----
1. Fixed a problem, introduced in V1.80, that stopped TNCs with WA8DED
firmware, and its derivatives, from being initialised correctly.

2. Filtering IGATE'd beacons now works retrospectively like all the
other filters.

3. If you used the exclude by distance option in "Exclude/Include
Lists", then it would sometimes be converted from miles to km, or vice
versa, for no apparent reason.

4. It was impossible to key in a '-' in the callsign lists in the
"Exclude/Include Lists" dialogue, so an SSID could not be specified.

5. Hopefully fixed some problems that occurred when UI-View32 had been
running for 24.85 days.

6. In certain situations, when posits from a station were being heard
both on the internet and on RF, an IGATE could incorrectly regard the
station as being local, and gate messages to it from the internet to
RF.

7. If a posit was received for a station, for which a details window
was already open, even if UI-View32 was minimized, the details window
would appear on the screen.

8. If the PC clock went backwards, then it could temporarily cause the
[INET_TO_RF_LIMITS] settings in IGATE.INI not to work.

9. Not really a bug, but the blue corners of map outlines were "hot",
even if Options, "Show Map Outlines" was not checked, and the outlines
were not showing.

10. I had two reports that some of the UI-View32 windows could only be
maximized or minimized, they would not display normally. I could not
reproduce the problem, but I have put in some extra checks to try and
make sure that, when loading the saved window positions, any invalid
values are discarded.

11. Not really a bug, more a change in behaviour - In previous
versions of UI-View32, if you were connected to an internet server,
and had some entries in IGATE.INI to force traffic from the internet
to RF, and were using a server that echoed the frames you gated, then
frames you gated from RF to the internet could be gated back to RF.
That will not now happen. (Note - in previous versions, it could not
cause a "loop", because the frames would not be gated to the internet
a second time.)


Roger Barker
roger@peaksys.co.uk
2004-Apr-14
